{$A+,B-,D-,E-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
USES
  dos;

TYPE
  srr1 = string[31];
  str7 = string[62];

CONST
  CL = #200;
  CR = #201;
  CU = #202;
  CD = #203;
  PU = #204;
  PD = #205;
  qf = 2560;
  HS = 8;  (* readF, loadbuf must set this value *)
  maxrows = 46;
  bufgs = maxrows*80;
  astr : string[57] =
    'Extra Font Editor V1.46 (C) Copyright V. Lidovski, 1992';
  trnv : array [0..1] of char = (' ', '');

VAR
  regs : registers;
  dset : set of 0..31;
  xf, bf : file of byte;
  bbp, bep, bufpos : longint;
  drivecount, VL, QH, QV, bms, VS, xg, yg, Fconst : byte;
(*
  bms 0: 1:beg 2:end;
  VS - Vertical Size of charcell
  Fconst - VS*HS div 8
*)
  fis, fsel, CF, mous, lowflag : boolean;
(*
  CF - state = saved buf?
  fis - File IS
  fsel - menu state = finamesel or blnamesel selected?
*)
  bufres, LSC, cstep, bstep, wn, wn2 : integer;
(*
  LSC = bufres div 8, bufsize in bytes
*)
  tom, wc, wc2 : char;
(*
  tom - type of mark:byte or char
*)
  bn, fn, ws, ws2 : srr1;
  war : array [0..20] of real;
  lbmp : array [1..bufgs] of byte;
  tbmp : array [1..maxrows, 1..80] of integer;
  filesarr : array [1..qf] of string[16];
  scrarr : array [1..250] of string[16];
  scrpos : byte;
  objinfo : searchrec;
  savepath : string[128];
  xstr : string[64];
  xpath : array [0..64] of byte absolute xstr;
  int1Bsave: pointer;

FUNCTION spa(n : byte) : str7;         (* s *)
  const
    s : string[80]=
'                                                                                ';
  begin
    s[0] := chr(n);
    spa := s
  end;

PROCEDURE gotoxy(x, y: byte);
  begin
    regs.ah := 2;
    regs.bh := 0;
    regs.dl := x - 1;
    regs.dh := y - 1;
    intr($10, regs)
  end;

FUNCTION wherex : byte;
  begin
    regs.ah := 3;
    regs.bh := 0;
    intr($10, regs);
    wherex := regs.dl + 1
  end;

FUNCTION wherey : byte;
  begin
    regs.ah := 3;
    regs.bh := 0;
    intr($10, regs);
    wherey := regs.dh + 1
  end;

PROCEDURE clreol;
  var
    x, y : byte;
  begin
    x := wherex;
    y := wherey;
    write(spa(81 - x));
    gotoxy(x, y)
  end;

PROCEDURE clrscr;
  var
    i : byte;
  begin
    for i := 1 to 60 do
      writeln;
    gotoxy(1, 1)
  end;

PROCEDURE writex(s: string);
  var
    x, y, i: byte;
  begin
    x := wherex;
    y := wherey;
    for i := 1 to length(s) do begin
      regs.ah := 9;
      regs.al := ord(s[i]);
      regs.cx := 1;
      if lowflag then
        regs.bx := $70
      else
        regs.bx := 7;
      intr($10, regs);
      inc(x);
      gotoxy(x, y)
    end
  end;

FUNCTION keypressed : boolean;                   (* wc *)
  label l1;
  begin
    keypressed := true;
    asm
      mov ah, 1
      int 16h
      jnz l1
    end;
    keypressed := false;
l1:
  end;

FUNCTION readkey : char;
  begin
    regs.ah := 8;
    msdos(regs);
    readkey := chr(regs.al)
  end;

PROCEDURE hidem; (*    *)
  begin
    if not mous then
      exit;
    regs.ax := 2;
    intr($33, regs)
  end;

PROCEDURE showm; (*    *)
  begin
    if not mous then
      exit;
    regs.ax := 1;
    intr($33, regs)
  end;

FUNCTION moi : boolean;
  (* 頥 true ᫨ 뫠      false ᫨ ,
      䥪 -   ॣ CX  DX ⥪ ⥪⮢
     न X  Y *)
  var
    tb : boolean;
  begin
    if mous then begin
      regs.ax := 3;
      intr($33, regs);
      regs.cx := regs.cx div 8 + 1;
      regs.dx := regs.dx div 8 + 1;
      tb := regs.bx and 3 > 0;
      moi := tb
    end else
      moi := false
  end;


PROCEDURE getk;
  (* 頥  wc ਯணࠬ  ⮩  *)

  procedure getk2;
  (* ᯮ⥫쭠  getk: 頥  wc ਯணࠬ
     ⮢  ⮩     ⠭
     㡠⮢  *)
    begin
      wc := readkey;
      if (wc > #58) and (wc < #64) then
        wc := chr(ord(wc) + 191);
      case wc of
        #75 : wc := CL;
        #77 : wc := CR;
        #72 : wc := CU;
        #73 : wc := PU;
        #80 : wc := CD;
        #81 : wc := PD
      end
    end;

  begin
    wc := readkey;
    if wc = #0 then
      getk2
  end;

FUNCTION bdir(s : str7) : boolean;
  BEGIN
    findfirst(s, $3F, objinfo);
    bdir := (doserror = 0) and (objinfo.size > 0)
  END;

PROCEDURE lowvideo;
  begin
    lowflag := true
  end;

PROCEDURE normvideo;
  begin
    lowflag := false
  end;

PROCEDURE curoff;
  begin
    regs.ax := $100;
    regs.cx := $2000;
    intr($10, regs)
  end;

PROCEDURE curon;
  begin
    regs.ax := $100;
    regs.cx := $0007;
    intr($10, regs)
  end;

PROCEDURE gtky(a : srr1; n : byte);    (* wc *)
  begin
    repeat
      getk;
      wc := upcase(wc)
    until pos(wc, a) > 0;
    if n > 0 then begin
      hidem;
      write(wc);
      showm
    end
  end;

PROCEDURE del(n : byte);
  var
    x : byte;
  begin
    hidem;
    for x := 1 to n do
      write(#8, ' ', #8);
    showm
  end;

PROCEDURE inpn(j, k, le, ml, mo : integer);     (* ws, ws2, wc, war *)
  (* j-k words with buffer=le & maxsumlength=ml, modus=mo
        mo=(0:inpn; 1:inpd; 2:inpn; 3:inp; 4:inpym) *)
  label
    1, 2, 3, 4, 5, 6, 7, 8, 0;
  var
    i, m, n : integer;
    c1, c2 : char;
  begin
    ws[0] := chr(le);
    if le = 0 then
      le := 1
    else
      le := 0;
    m := 0;
    n := 0;
    c2 := #31;
    c1 := ',';
    case mo of
      0: c2 := '.';
      1: c1 := '-';
      3: c1 := #31;
      4: c1 := '/'
    end;
    ws2 := '1234567890'#13#8 + c1 + c2 + CL + #27;
  1:i := length(ws);
  2:if mo = 3 then
      getk
    else
      gtky(ws2, 0);
    if wc = #27 then begin
      ws := '-1.1111';
      goto 6
    end;
    if wc = CL then
      wc := #8;
    if (i = ml) and (wc <> #13) and (wc <> #8) then
      goto 2;
    if wc = c1 then
      goto 4;
    if wc = #13 then
      if mo = 3 then
        goto 6
      else
        goto 3;
    goto 5;
  3:if (le = 0) and (m + 1 >= j) then
      goto 6
    else
      goto 1;
  4:if le = 1 then
      goto 1
    else begin
      n := 0;
      le := 1;
      m := m + 1;
      goto 0
    end;
  5:if wc = #8 then
      goto 8;
    le := 0;
    if wc <> c2 then
      goto 7;
    if n = 0 then
      n := 1
    else
      goto 1;
  7:ws := ws + wc;
    hidem;
    write(wc);
    showm;
    goto 1;
  8:if i = 0 then
      goto 1
    else if i = 1 then
      le := 1;
    del(1);
    if ws[i] = c2 then
      n := 0;
    if ws[i] = c1 then begin
      m := m - 1;
      n := i;
      repeat
        n := n - 1
      until (ws[n] = c1) or (ws[n] = c2) or (n = 1);
      if ws[n] = c2 then
        n := 1
      else
        n := 0
    end;
    i := i - 1;
    if ws[i] = c1 then
      le := 1;
    ws[0] := chr(i);
    goto 1;
  0:if k <> m then
      goto 7;
  6:m := 0;
    repeat
      m := m + 1;
      ws2 := ws;
      i := pos(c1, ws);
      if i <> 0 then begin
        ws2[0] := chr(i - 1);
        delete(ws, 1, i)
      end;
      val(ws2, war[m], le)
    until i = 0;
    war[0] := m
  end;

PROCEDURE inpnu(n, le : integer; var m : integer);     (* wc, ws, ws2, war *)
  begin
    inpn(1, 1, le, n, 2);
    m := round(war[1])
  end;

FUNCTION min(a, b : longint) : longint;
  begin
    if a > b then
      min := b
    else
      min := a
  end;

PROCEDURE qsort(N : integer; S : byte);  (* Shell's prime numbers *)
  CONST
    steps : array [0..11] of word =
      (1279, 641, 317, 163, 79, 41, 19, 11, 5, 3, 1, 0);
  VAR
    j : integer;
    gap, ii : word;
    c3 : byte;
    li : string[16];
  begin
    c3 := 0;
    gap := steps[c3];
    repeat
      inc(c3);
      for ii := gap to N - 1 do begin
        j := ii - gap + 1;
        while (j > 0) and (filesarr[j + S] > filesarr[j + gap + S]) do begin
          li := filesarr[j + S];
          filesarr[j + S] := filesarr[j + gap + S];
          filesarr[j + gap + S] := li;
          j := j - gap
        end
      end;
      gap := steps[c3]
    until gap = 0;
  end;

PROCEDURE decod(b : byte; i : integer);
  var j : byte;
  begin
    lbmp[i*8 + 1] := b div 128;
    b := b mod 128;
    lbmp[i*8 + 2] := b div 64;
    b := b mod 64;
    lbmp[i*8 + 3] := b div 32;
    b := b mod 32;
    lbmp[i*8 + 4] := b div 16;
    b := b mod 16;
    lbmp[i*8 + 5] := b div 8;
    b := b mod 8;
    lbmp[i*8 + 6] := b div 4;
    b := b mod 4;
    lbmp[i*8 + 7] := b div 2;
    b := b mod 2;
    lbmp[i*8 + 8] := b
  end;

FUNCTION coder(i : integer) : byte;
  var j : byte;
  begin
    j := 0;
    if lbmp[i*8 + 1] = 1 then j := 128;
    if lbmp[i*8 + 2] = 1 then j := j+64;
    if lbmp[i*8 + 3] = 1 then j := j+32;
    if lbmp[i*8 + 4] = 1 then j := j+16;
    if lbmp[i*8 + 5] = 1 then j := j+8;
    if lbmp[i*8 + 6] = 1 then j := j+4;
    if lbmp[i*8 + 7] = 1 then j := j+2;
    if lbmp[i*8 + 8] = 1 then j := j+1;
    coder := j
  end;

PROCEDURE savebuf;
  var
    j : byte;
    i : integer;
  begin
    CF := false;
    seek(xf, bufpos);
    for i := 0 to LSC - 1 do begin
      j := coder(i);
      write(xf, j)
    end;
    gotoxy(1, VL + 4);
    hidem;
    write(' ');
    showm;
    gotoxy(xg, yg)
  end;

PROCEDURE loadbuf;
  var
    b : byte;
    i, qc, qfl : integer;
  begin
    hidem;
    gotoxy(4, VL + 3);
    write(bufpos + 1 : 10);
    showm;
    seek(xf, bufpos);
    i := 0;
    repeat
      read(xf, b);
      decod(b, i);
      i := i + 1
    until eof(xf) or (i = LSC);
    if eof(xf) and (i <> LSC) then begin
      LSC := i;
      bufres := i*8;
      qc := bufres div (VS*HS); (* QChars *)
      qfl := qc div (80 div HS); (* QFullLines *)
      if qfl = 0 then begin
        if qc > 0 then
          QH := qc*HS
        else begin
          while bufres div (VS*HS) = 0 do
            dec(VS);
          Fconst := VS*HS div 8;
          gotoxy(1, QV + 1);
          hidem;
          curoff;
          for wn := QV + 1 to VL do begin
            clreol;
            writeln
          end;
          gotoxy(11, VL + 2);
          write(VS : 2);
          curon;
          showm;
          QH := HS
        end;
        QV := VS;
        hidem;
        for i := 1 to QV do begin
          gotoxy(QH + 1, i);
          clreol
        end;
        showm
      end else begin
        QV := qfl*VS;
        QH := 80;
        bufres := qfl*(80 div HS)*VS*HS;
        LSC := bufres div 8
      end;
      gotoxy(1, QV + 1);
      hidem;
      curoff;
      for wn := QV + 1 to VL do begin
        clreol;
        writeln
      end;
      showm;
      curon;
      xg := 1;
      yg := 1
    end
  end;

PROCEDURE saveblock(qbs : integer);
  var
    j : byte;
    i : integer;
  begin
    for i := 0 to qbs - 1 do begin
      j := coder(i);
      write(bf, j)
    end
  end;

PROCEDURE loadblock(qbl : integer; pbf : longint);
  var
    b : byte;
    i : integer;
  begin
    seek(xf, pbf);
    i := 0;
    while i < qbl do begin
      read(xf, b);
      decod(b, i);
      inc(i)
    end
  end;

PROCEDURE byteL(m : integer);
  begin
    if CF then
      savebuf;
    if bufpos + LSC + m <= filesize(xf) then begin
      bufpos := bufpos + m;
      loadbuf
    end
  end;

PROCEDURE byteR(m : integer);
  begin
    if CF then
      savebuf;
    if bufpos - m >= 0 then begin
      bufpos := bufpos - m;
      loadbuf
     end
  end;

PROCEDURE moveL;
  var i : integer;
  begin
    case tom of
      'Y': byteL(bstep);
      'H': byteL(cstep*Fconst)
    end
  end;

PROCEDURE moveR;
  var i : integer;
  begin
    case tom of
      'Y': byteR(bstep);
      'H': byteR(cstep*Fconst)
    end
  end;

PROCEDURE viewbmarks;
  var
    v1, n1, n2, n3, n5, i : integer;
    v2, x, y : byte;
  begin
    if (bbp*8 >= bufpos*8) and (bbp*8 <= bufpos*8 + bufres - 1) then begin
      i := (bbp - bufpos)*8;
      v2 := 80 div HS;
      v1 := HS*VS;
      hidem;
      n1 := i div v1;   (* current full box number *)
      n2 := i - n1*v1;  (* remainder in current box *)
      n5 := n1 div v2;  (* current full box's line *)
      n3 := n2 div HS;  (* current full line in box *)
      y := n5*VS + n3 + 1;
      x := (n1 - n5*v2)*HS + n2 - n3*HS + 1;
      if (y <= QV) and (x <= QH) then begin
        gotoxy(x, y);
        hidem;
        write('B');
        showm;
      end;
      showm
    end;
    if (bep*8 >= bufpos*8) and (bep*8 <= bufpos*8 + bufres - 1) then begin
      i := (bep - bufpos)*8 + HS - 1;
      v2 := 80 div HS;
      v1 := HS*VS;
      hidem;
      n1 := i div v1;    (* current full box number *)
      n2 := i - n1*v1;   (* remainder in current box *)
      n5 := n1 div v2;   (* current full box's line *)
      n3 := n2 div HS;   (* current full line in box *)
      y := n5*VS + n3 + 1;
      x := (n1 - n5*v2)*HS + n2 - n3*HS + 1;
      if (y <= QV) and (x <= QH) then begin
        gotoxy(x, y);
        hidem;
        write('E');
        showm
      end;
      showm
    end
  end;

PROCEDURE viewbuf;
  var
    v1, n1, n2, n3, n5, i : integer;
    v2, x, y : byte;
  begin
    curoff;
    v2 := 80 div HS;
    v1 := HS*VS;
    hidem;
    gotoxy(1, 1);
    for i := 0 to bufres - 1 do begin
      n1 := i div v1;    (* current full box number *)
      n2 := i - n1*v1;   (* remainder in current box *)
      n5 := n1 div v2;   (* current full box's line *)
      n3 := n2 div HS;   (* current full line in box *)
      y := n5*VS + n3 + 1;
      x := (n1 - n5*v2)*HS + n2 - n3*HS + 1;
      if (y <= QV) and (x <= QH) then begin
        gotoxy(x, y);
        tbmp[y, x] := i + 1;
        write(trnv[lbmp[i + 1]])
      end
    end;
    curon;
    showm
  end;

PROCEDURE vmenu;
  begin
    hidem;
    case wc of
     'B': begin gotoxy(74, VL + 2); writex(' Begin ') end;
     'D': begin gotoxy(74, VL + 3); writex(' enD   ') end;
     'Q': begin gotoxy(74, VL + 4); writex(' Quit ') end;
     'Y': begin gotoxy(56, VL + 3); writex(' bYte(s) ') end;
     'H': begin gotoxy(56, VL + 4); writex(' cHar(s) ') end;
     'L': begin gotoxy(44, VL + 2); writex('  Left     ') end;
     'G': begin gotoxy(44, VL + 3); writex(' riGht     ') end;
     'S': begin gotoxy(44, VL + 4); writex(' Step ') end;
     'N': begin gotoxy(24, VL + 2); writex(' Name ') end;
     'R': begin gotoxy(24, VL + 3); writex(' Read    ') end;
     'M': begin gotoxy(24, VL + 4); writex(' Mark    ') end;
     'W': begin gotoxy(34, VL + 3); writex(' Write   ') end;
     'U': begin gotoxy(34, VL + 4); writex(' Undo    ') end;
     'E': begin gotoxy(16, VL + 2); writex(' filE  ') end;
     'O': begin gotoxy(16, VL + 3); writex(' blOck ') end;
     'T': begin gotoxy(16, VL + 4); writex(' selecT') end;
     'F': begin gotoxy(66, VL + 2); writex(' Fill  ') end;
     'A': begin gotoxy(66, VL + 3); writex(' cleAr ') end;
     'I': begin gotoxy(66, VL + 4); writex(' Inv.  ') end;
     'V': begin gotoxy(1, VL + 2); writex('Ver size') end
    end;
    gotoxy(xg, yg);
    showm
  end;

PROCEDURE scr1;
  var
    i, j : integer;
  begin
    hidem;
    clrscr;
    gotoxy(1, VL + 2);
    write('Ver.size <', VS : 2, '>');
    gotoxy(1, VL + 3);
    write('fp=        1');
    gotoxy(1, VL + 4);
    write('   x= 0  y= 0');
    gotoxy(14, VL + 2);
    write(' | filE  | Name  ', bn);
    gotoxy(14, VL + 3);
    write(' | blOck | Read    | Write');
    gotoxy(14, VL + 4);
    write(' | selecT| Mark    | Undo');
    gotoxy(43, VL + 2);
    write('|  Left     |         |');
    gotoxy(43, VL + 3);
    write('| riGht     | bYte(s) |');
    gotoxy(43, VL + 4);
    write('| Step <');
    if tom = 'Y' then
      write(bstep : 2)
    else
      write(cstep : 2);
    write('> | cHar(s) |');
    gotoxy(66, VL + 2);
    write(' Fill');
    gotoxy(66, VL + 3);
    write(' cleAr');
    gotoxy(66, VL + 4);
    write(' Inv.');
    gotoxy(73, VL + 2);
    write('| Begin');
    gotoxy(73, VL + 3);
    write('| enD');
    gotoxy(73, VL + 4);
    write('| Quit');
    lowvideo;
    if tom = 'Y' then begin
      wc := 'Y';
      vmenu
    end else begin
      wc := 'H';
      vmenu
    end;
    if fsel then begin
      wc := 'E';
      vmenu
    end else begin
      wc := 'O';
      vmenu
    end;
    normvideo;
    gotoxy(11, VL + 1);
    write(astr);
    loadbuf;
    viewbuf;
    showm
  end;

PROCEDURE readF;
  begin
    assign(xf, fexpand(fn));
    reset(xf);
    wn := (80 div HS)*(VL div VS)*VS*HS;
    bufres := wn;
    LSC := wn div 8;
    QH := 80;
    QV := (VL div VS)*VS;
    CF := false;
    bms := 0;
    bbp := -1;
    bep := -1;
    bufpos := 0
  end;

PROCEDURE prep;
  begin
    for wn := 1 to bufgs do
      lbmp[wn] := 2;
    if paramcount > 1 then begin
      writeln('USAGE: xfed [<filename>]');
      halt
    end;
    if paramcount=0 then begin
      fn := 'new.fnt';
      assign(xf, fexpand(fn));
      rewrite(xf);
      xg := 0;
      write(xf, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg, xg);
      close(xf)
    end else
      fn := paramstr(1);
    if not bdir(fn) then begin
      writeln(fn,  ' not found');
      halt
    end;
    if astr[42] <> 'L' then (* security *)
      exit;
    gotoxy(1, 1);
    wn := 1;
    while wn = wherey do begin
      inc(wn);
      writeln
    end;  (* detect qu of screan rows *)
    VL := wn - 5;
    gotoxy(1, 1);
    wn := 1;
    while wn = wherex do begin
      inc(wn);
      write(' ')
    end;
    if not (VL in [21, 39, 46]) or (wn <> 81) then begin
      clrscr;
      writeln('This program supports only 25, 43, 50 rows by 80 columns screen');
      halt
    end;
    tom := 'H';
    bstep := 1;
    cstep := 10;
    VS := 21;
    readF;
    loadbuf;
    Fconst := VS*HS div 8;
    bms := 0;
    bbp := -1;
    bep := -1;
    fsel := false;
    bn := 'CLIPBRD.FNT';
    fis := bdir(bn);
    assign(bf, fexpand(bn));
    filesarr[1] := '<<Escape>>      ';
    regs.ah := $52;
    msdos(regs);
    drivecount := 1;
    dset := [0];
    wn2 := mem[regs.es : regs.bx + $21];
    for wn := 1 to wn2 do begin
      regs.ax := $4408;
      regs.bl := wn;
      msdos(regs);
      if regs.ax <> $f then begin
        regs.ax := $440e;
        regs.bl := wn;
        msdos(regs);
        if regs.al = 0 then
          regs.al := wn;
        if not (regs.al in dset) then begin
          inc(drivecount);
          filesarr[drivecount] := '[' + chr(64 + regs.al) + ':]' + spa(12);
          dset := dset + [regs.al]
        end
      end
    end;
    curon;
    xg := 1;
    yg := 1;
    regs.ax := 0;
    intr($33, regs);
    mous := regs.ax = $FFFF; (*   ? *)
    showm
  end;

PROCEDURE error;
  begin
    clrscr;
    if astr[39] = 'i' then
      close(xf);
    hidem;
    regs.ax := $100;
    regs.cx := $0607;
    intr($10, regs);
    clrscr
  end;

PROCEDURE setCF;
  begin
    gotoxy(1, VL + 4);
    hidem;
    write('*');
    CF := true;
    showm;
  end;

PROCEDURE changebit(x, y : byte);
  begin
    case lbmp[tbmp[y, x]] of
      0: lbmp[tbmp[y, x]] := 1;
      1: lbmp[tbmp[y, x]] := 0;
    end;
    setCF;
    hidem;
    gotoxy(x, y);
    write(trnv[lbmp[tbmp[y, x]]]);
    showm
  end;

PROCEDURE changeVS(nv : integer);
  begin
    if (nv < VL + 1) and (nv > 0) then
      VS := nv;
    QV := (VL div VS)*VS;
    wn := (80 div HS)*QV*HS;
    bufres := wn;
    LSC := wn div 8;
    xg := 1;
    yg := 1;
    loadbuf;
    Fconst := VS*HS div 8;
    gotoxy(1, QV + 1);
    hidem;
    curoff;
    for wn := QV + 1 to VL do begin
      clreol;
      writeln
    end;
    gotoxy(11, VL + 2);
    write(VS : 2);
    curon;
    showm;
    viewbuf
  end;

FUNCTION selectfile : boolean;
  label
    1, 2, 3, 4, 5, 7, 8;
  var
    otime, ntime : longint;
    x, y, xo, yo : byte;
    de, scrcap, scritems : byte;
    i, oe, t : integer;

  begin
    savepath := fexpand('.');
  2:oe := drivecount;
    FindFirst('*.*',  directory,  objinfo);
    while DosError = 0 do begin
      if objinfo.attr and $10 > 0 then begin
        inc(oe);
        filesarr[oe] := '[' + objinfo.Name + ']'
          + spa(14 - length(objinfo.Name))
      end;
      FindNext(objinfo)
    end;
    de := oe;
    FindFirst('*.*',  archive,  objinfo);
    while DosError = 0 do begin
      if oe < qf then begin
        inc(oe);
        filesarr[oe] := objinfo.Name + spa(16 - length(objinfo.Name));
        FindNext(objinfo)
      end else
        break
    end;
    if oe - de > 1 then
      qsort(oe - de, de);
    scrcap := (VL + 4)*5;
    scrpos := 0;
  4:x := 1;
    y := 1;
    xo := 1;
    yo := 1;
    t := oe - scrpos*scrcap;
    scritems := scrcap;
    if t > scrcap - 2 then
      t := scrcap - 2
    else
      scritems := t + 2;
    scrarr[scritems - 1] := '<<Page Up>>     ';
    scrarr[scritems] := '<<Page Down>>  ';
    for i := 1 to t do
      scrarr[i] := filesarr[scrpos*scrcap + i];
    curoff;
    hidem;
    clrscr;
    for i := 1 to scritems do
      write(scrarr[i]);
    showm;
  7:gotoxy(xo, yo);
    hidem;
    writex(scrarr[(yo - 1)*5 + xo div 16 + 1]);
    xo := x;
    yo := y;
    gotoxy(x, y);
    lowvideo;
    writex(scrarr[(y - 1)*5 + x div 16 + 1]);
    normvideo;
    showm;
  1:if keypressed then begin
      getk;
      wc := upcase(wc);
      if pos(wc, CL + CR + CU + CD + #13#27 + PU + PD) = 0 then
        goto 1
    end else if moi and (regs.dl*5 + regs.cl div 16 - 4 <= scritems) then begin
      y := regs.dl;
      x := (regs.cl div 16)*16 + 1;
      otime := ntime;
      regs.ah := 0;
      intr($1a, regs);
      ntime := regs.cx*$10000 + regs.dx;
      if ntime - otime < 9 then
        wc := #13
      else
        wc := #31
    end else
      goto 1;
    while moi do;
    case wc of
      CL:
        if x > 16 then
          x := x - 16
        else begin
          x := 65;
          while y*5 + x div 16 - 4 > scritems do
            x := x - 16
        end;
      CR:
        if (y*5 + x div 16 - 3 <= scritems) and (x < 65) then
          x := x + 16
        else
          x := 1;
      CU:
        if y > 1 then
          y := y-1
        else
          while y*5 + x div 16 + 1 <= scritems do
            inc(y);
      CD:
        if (y*5 + x div 16 + 1 <= scritems) and (y < VL + 4) then
          y := y + 1
        else
          y := 1;
      #13:
        begin
          i := (y - 1)*5 + x div 16 + 1;
          if pos('<<Escape>>', scrarr[i]) > 0 then
            goto 8;
          if scrarr[i][3] = ':' then begin
            regs.ah := $0e;
            regs.dl := ord(scrarr[i][2]) - 65;
            msdos(regs);
            goto 2
          end;
          if scrarr[i][1] = '[' then begin
            xstr := copy(scrarr[i], 2, pos(']', scrarr[i]) - 2);
            xstr := fexpand(xstr);
            xpath[length(xstr) + 1] := 0;
            regs.ah := $3b;
            regs.ds := dseg;
            regs.dx := ofs(xpath) + 1;
            msdos(regs);
            goto 2
          end;
          if pos('<<Page Up>>', scrarr[i]) > 0 then
            goto 3;
          if pos('<<Page Down>>', scrarr[i]) > 0 then
            goto 5;
          if bdir(scrarr[i]) then begin
            if fsel then begin
              fn := scrarr[i];
              fn[0] := #12
            end else begin
              bn := scrarr[i];
              bn[0] := #12
            end;
            selectfile := true;
            curon;
            exit
          end else
            goto 2
        end;
      PU:
        begin
        3:if scrpos > 0 then begin
            dec(scrpos);
            goto 4
          end
        end;
      PD:
        begin
        5:if oe - (scrpos + 1)*scrcap > 0 then begin
            inc(scrpos);
            goto 4
          end
        end;
      #27:
        begin
        8:selectfile := false;
          chdir(savepath);
          curon;
          exit
        end
    end;
    goto 7
  end;

PROCEDURE menu;
  label 7;
  var
    x, y, xo, yo : byte;
    i, j : integer;
    l : longint;
  begin
    scr1;
  7:if (xo <> xg) or (yo <> yg) then begin
      hidem;
      gotoxy(6, VL + 4);
      write(xg : 2);
      gotoxy(12, VL + 4);
      write(yg : 2);
      showm
    end;
    xo := xg;
    yo := yg;
    gotoxy(xg, yg);
    wc := #31;
    if keypressed then begin
      getk;
      wc := upcase(wc);
      if pos(wc, 'ABDEFGHILMNOQRSTUVWY ' + CL + CR + CU + CD) = 0 then
        goto 7
    end else if moi then
      case VL + 4 - regs.dl of
        2:
          case regs.cx of
            1..8, 11, 12:
              wc := 'V';
            10:
              if VS > 1 then begin
                wn := VS - 1;
                changeVS(wn)
              end;
            13:
              if VS < VL then begin
                wn := VS + 1;
                changeVS(wn)
              end;
            16..22: wc := 'E';
            24..42: wc := 'N';
            44..54: wc := 'L';
            66..72: wc := 'F';
            74..80: wc := 'B'
          end;
        1:
          case regs.cx of
            16..22: wc := 'O';
            24..32: wc := 'R';
            34..42: wc := 'W';
            44..54: wc := 'G';
            56..64: wc := 'Y';
            66..72: wc := 'A';
            74..80: wc := 'D'
          end;
        0:
          case regs.cx of
            16..22: wc := 'T';
            24..32: wc := 'M';
            34..42: wc := 'U';
            44..48, 51, 52: wc := 'S';
            50:
              case tom of
                'Y':
                  if bstep > 0 then begin
                    dec(bstep);
                    gotoxy(51, VL + 4);
                    hidem;
                    write(bstep : 2);
                    showm
                  end;
                'H':
                  if cstep > 0 then begin
                    dec(cstep);
                    gotoxy(51, VL + 4);
                    hidem;
                    write(cstep : 2);
                    showm
                  end
              end;
            53:
              case tom of
                'Y':
                  if bstep < 99 then begin
                    inc(bstep);
                    gotoxy(51, VL + 4);
                    hidem;
                    write(bstep : 2);
                    showm
                  end;
                'H':
                  if cstep < 99 then begin
                    inc(cstep);
                    gotoxy(51, VL + 4);
                    hidem;
                    write(cstep : 2);
                    showm
                  end
              end;
            56..64: wc := 'H';
            66..72: wc := 'I';
            74..80: wc := 'Q'
          end;
      else
          if (regs.dx <= QV) and (regs.cx <= QH) then begin
            x := regs.cx;
            y := regs.dx;
            if regs.bx and 2 = 0 then begin
              xg := x;
              yg := y;
              goto 7
            end else begin
              while moi do;
              changebit(x, y);
              goto 7
            end
          end
      end
    else
      goto 7;
    lowvideo;
    vmenu;
    normvideo;
    while moi do;
    case wc of
      'T':
        begin
          if CF then
            savebuf;
          if selectfile then begin
            case fsel of
              false:
                begin
                  scr1;
                  fis := true;
                  assign(bf, fexpand(bn));
                  gotoxy(30, VL + 2);
                  hidem;
                  write(bn : 12);
                  showm
                 end;
              true:
                begin
                  close(xf);
                  readF;
                  loadbuf;
                  scr1;
                  gotoxy(30, VL + 2);
                  hidem;
                  write(fn : 12);
                  showm;
                  viewbuf
                end
            end
          end else
            scr1;
          wc := #31
        end;
      ' ':
        begin
          changebit(xg, yg);
          if xg < QH then
            xg := xg + 1
          else
            xg := 1;
          viewbmarks
        end;
      'Q':
        begin
          if CF then
            savebuf;
          exit
        end;
      'Y', 'H':
        begin
          wc2 := tom;
          tom := wc;
          if wc <> wc2 then
            wc := wc2
          else
            wc := #31;
          hidem;
          gotoxy(51, VL + 4);
          case tom of
            'Y': write(bstep : 2);
            'H': write(cstep : 2)
          end;
          showm
        end;
      'V':
        begin
          gotoxy(13, VL + 2);
          del(2);
          inpnu(2, 0, wn);
          if wn = -1 then
            wn := VS;
          changeVS(wn);
          viewbmarks;
          wc := 'V'
        end;
      CL: if xg > 1 then xg := xg - 1 else xg := QH;
      CR: if xg < QH then xg := xg + 1 else xg := 1;
      CU: if yg > 1 then yg := yg - 1 else yg := QV;
      CD: if yg < QV then yg := yg + 1 else yg := 1;
      'F':
        begin
          setCF;
          hidem;
          curoff;
          for x := ((xg - 1) div HS)*HS + 1 to ((xg - 1) div HS + 1)*HS do
            for y := ((yg - 1) div VS)*VS + 1 to ((yg - 1) div VS + 1)*VS do
            begin
              lbmp[tbmp[y, x]] := 1;
              gotoxy(x, y);
              write(trnv[lbmp[tbmp[y, x]]])
            end;
          viewbmarks;
          curon;
          showm
        end;
      'A':
        begin
          setCF;
          hidem;
          curoff;
          for x := ((xg - 1) div HS)*HS + 1 to ((xg - 1) div HS + 1)*HS do
            for y := ((yg - 1) div VS)*VS + 1 to ((yg - 1) div VS + 1)*VS do
            begin
              lbmp[tbmp[y, x]] := 0;
              gotoxy(x, y);
              write(trnv[lbmp[tbmp[y, x]]])
            end;
          viewbmarks;
          curon;
          showm
        end;
      'I':
        begin
          setCF;
          hidem;
          curoff;
          for x := ((xg - 1) div HS)*HS + 1 to ((xg - 1) div HS + 1)*HS do
            for y := ((yg - 1) div VS)*VS + 1 to ((yg - 1) div VS + 1)*VS do
            begin
              case lbmp[tbmp[y, x]] of
                0: lbmp[tbmp[y, x]] := 1;
                1: lbmp[tbmp[y, x]] := 0;
              end;
              gotoxy(x, y);
              write(trnv[lbmp[tbmp[y, x]]])
            end;
          viewbmarks;
          curon;
          showm
        end;
      'L':
        begin
          moveL;
          viewbuf;
          viewbmarks
        end;
      'G':
        begin
          moveR;
          viewbuf;
          viewbmarks
        end;
      'B':
        begin
          if CF then
            savebuf;
          bufpos := 0;
          loadbuf;
          viewbuf;
          viewbmarks
        end;
      'D':
        begin
          if CF then
            savebuf;
          bufpos := filesize(xf) - LSC;
          loadbuf;
          viewbuf;
          viewbmarks
        end;
      'S':
        begin
          gotoxy(53, VL + 4);
          del(2);
          inpnu(2, 0, wn);
          if wn <> -1 then
            case tom of
              'Y': bstep := wn;
              'H': cstep := wn
            end;
          gotoxy(51, VL + 4);
          hidem;
          case tom of
            'Y': write(bstep : 2);
            'H': write(cstep : 2)
           end;
           showm;
           wc := 'S'
         end;
      'N':
        begin
          gotoxy(42, VL + 2);
          del(12);
          gotoxy(42, VL + 2);
          del(12);
          inpn(1, 1, 0, 12, 3);
          if ws <> '-1.1111' then begin
            if fsel then
              if bdir(ws) then begin
                fn := ws;
                close(xf);
                readF;
                loadbuf;
                viewbuf
              end else
                ws := fn
            else begin
              bn := ws;
              fis := bdir(ws);
              assign(bf, fexpand(bn))
            end
          end;
          gotoxy(30, VL + 2);
          hidem;
          if fsel then
            write(fn : 12)
          else
            write(bn : 12);
          showm;
          wc := 'N'
        end;
      'M':
        begin
          case bms of
            1:
              begin
                i := tbmp[yg, xg] - 1;
                if tom = 'Y' then
                  bep := bufpos + i div 8
                else
                  bep := bufpos + (i div (8*VS))*VS+VS - 1;
                bms := 2
              end;
            0, 2:
              begin
                i := tbmp[yg, xg] - 1;
                if tom = 'Y' then
                  bbp := bufpos + i div 8
                else
                  bbp := bufpos + (i div (8*VS))*VS;
                bms := 1;
                bep := -1
              end;
          end;
          viewbuf;
          viewbmarks
        end;
      'O':
        begin
          fsel := false;
          gotoxy(30, VL + 2);
          hidem;
          write(bn : 12);
          showm;
          wc := 'E'
        end;
      'E':
        begin
          fsel := true;
          gotoxy(30, VL + 2);
          if length(fn) > 12 then begin
            ws := fn;
            ws[0] := #12
          end else
            ws := fn;
          hidem;
          write(ws : 12);
          showm;
          wc := 'O'
        end;
      'U':
        if CF then begin
          loadbuf;
          viewbuf;
          viewbmarks;
          savebuf
        end;
      'R':
        begin
          i := tbmp[yg, xg] - 1;
          if fis then begin
            if CF then
              savebuf;
            j := bbp;
            if tom = 'Y' then
              bbp := bufpos + i div 8
            else
              bbp := bufpos + (i div (8*VS))*VS;
            reset(bf);
            seek(xf, bbp);
            repeat
              read(bf, x);
              write(xf, x)
            until eof(bf);
            close(bf);
            bbp := j;
            loadbuf;
            viewbuf;
            viewbmarks
          end
        end;
      'W':
        if bms=2 then begin
          if CF then
            savebuf;
          rewrite(bf);
          l := bep - bbp + 1;
          i := 0;
          while l > 0 do begin
            if l > LSC - 1 then begin
              loadblock(LSC, bbp + i);
              j := LSC;
              saveblock(j);
              i := i + j;
              l := l - j
            end else begin
              j := l;
              loadblock(j, bbp + i);
              saveblock(j);
              l := 0
            end
          end;
          fis := true;
          loadbuf;
          close(bf)
        end
    end;
    vmenu;
    goto 7
  end;

BEGIN
  prep;
  menu;
  error
END.

